package cn.com.infosec.jce.provider;

import java.math.BigInteger;
import java.security.PublicKey;
import java.util.Arrays;

public class JCESM2PublicKey implements PublicKey {
   private int bits;
   private byte[] x;
   private byte[] y;
   private byte[] encoded;
   private byte[] head;

   public JCESM2PublicKey() {
      this.bits = 256;
      this.head = new byte[]{48, 89, 48, 19, 6, 7, 42, -122, 72, -50, 61, 2, 1, 6, 8, 42, -127, 28, -49, 85, 1, -126, 45, 3, 66, 0, 4};
      this.x = new byte[32];
      this.y = new byte[32];
   }

   public JCESM2PublicKey(byte[] pubk) {
      JCESM2PublicKey var10001 = this;
      JCESM2PublicKey var10005 = this;
      super();
      this.bits = 256;
      this.head = new byte[]{48, 89, 48, 19, 6, 7, 42, -122, 72, -50, 61, 2, 1, 6, 8, 42, -127, 28, -49, 85, 1, -126, 45, 3, 66, 0, 4};
      byte[] var2;
      this.x = var2 = new byte[32];
      var10005.y = new byte[32];
      System.arraycopy(pubk, pubk.length - 64, var2, 0, 32);
      int var3 = pubk.length - 32;
      System.arraycopy(pubk, var3, var10001.y, 0, 32);
   }

   public int getBits() {
      return this.bits;
   }

   public void setBits(int bits) {
      this.bits = bits;
   }

   public byte[] getX() {
      return this.x;
   }

   public void setX(byte[] x) {
      this.encoded = null;
      System.arraycopy(x, 0, this.x, 0, 32);
   }

   public byte[] getY() {
      return this.y;
   }

   public void setY(byte[] y) {
      this.encoded = null;
      System.arraycopy(y, 0, this.y, 0, 32);
   }

   public byte[] getEncoded() {
      byte[] var1;
      if ((var1 = this.encoded) != null) {
         return var1;
      } else {
         JCESM2PublicKey var10000 = this;
         byte[] var10003 = this.head;
         this.encoded = var1 = new byte[var10003.length + 64];
         int var2 = var10003.length;
         System.arraycopy(var10003, 0, var1, 0, var2);
         var1 = this.encoded;
         var2 = this.head.length;
         System.arraycopy(this.x, 0, var1, var2, 32);
         byte[] var10001 = this.y;
         JCESM2PublicKey var10002 = this;
         byte[] var3 = this.encoded;
         int var4 = var10002.head.length + 32;
         System.arraycopy(var10001, 0, var3, var4, 32);
         return var10000.encoded;
      }
   }

   public String getAlgorithm() {
      return "EC";
   }

   public String getFormat() {
      return "X.509";
   }

   public int hashCode() {
      return (new BigInteger(this.getEncoded())).hashCode();
   }

   public boolean equals(Object o) {
      if (o == null) {
         return false;
      } else if (this == o) {
         return true;
      } else if (o instanceof JCESM2PublicKey) {
         JCESM2PublicKey var10000 = this;
         JCESM2PublicKey var2 = (JCESM2PublicKey)o;
         return Arrays.equals(var10000.getEncoded(), var2.getEncoded());
      } else {
         return false;
      }
   }
}
